<template>
    <div>
        <ValidationObserver v-slot="{ handleSubmit }" ref="form">
            <form @submit.prevent="handleSubmit(submitForm())">
                <ValidationProvider class="form-group" rules="required" v-slot="{ errors }">
                    <input v-model="address.fullName" type="text" id="f-name"
                           :class="{'invalid': errors.length}"
                           v-typed/>
                    <label for="f-name" class="required">Your Name</label>
                </ValidationProvider>
                <ValidationProvider class="form-group" rules="required"
                                    v-slot="{ errors }">
                    <input v-model="address.address" type="text" id="f-address"
                           :class="{'invalid': errors.length}"
                           v-typed/>
                    <label for="f-address" class="required">Your Address</label>
                </ValidationProvider>
                <div class="form-group country" :class="{
                                        'focus': countrySelect,
                                        'selected': address.country.length,
                                        'invalid': submit && !address.country.length
                                    }">
                    <v-select
                            v-model="address.country"
                            :components="{OpenIndicator}"
                            class="style-checkout"
                            :clearable="false"
                            :options="countries"
                            placeholder="Start Typing"
                            @search:focus="onSelectFocus('countrySelect')"
                            @search:blur="onSelectBlur('countrySelect')"
                    >
                    </v-select>
                    <label class="required">Country</label>
                </div>
                <ValidationProvider class="form-group city" rules="required" v-slot="{ errors }">
                    <input v-model="address.city" type="text" id="f-city"
                           :class="{'invalid': errors.length}"
                           v-typed/>
                    <label for="f-city" class="required">City</label>
                </ValidationProvider>
                <div class="form-group state" :class="{
                                        'focus': stateSelect,
                                        'selected': address.state.length,
                                        'invalid': submit && !address.state.length
                                    }">
                    <v-select
                            v-model="address.state"
                            :components="{OpenIndicator}"
                            class="style-checkout"
                            :clearable="false"
                            :options="states"
                            placeholder="Start Typing"
                            :disabled="!address.country"
                            @search:focus="onSelectFocus('stateSelect')"
                            @search:blur="onSelectBlur('stateSelect')"
                    >
                    </v-select>
                    <label class="required">State</label>
                </div>
                <ValidationProvider class="form-group zip" rules="required"
                                    v-slot="{ errors }">
                    <input v-model="address.zip" type="tel" id="f-zip"
                           :class="{'invalid': errors.length}"
                           v-typed/>
                    <label for="f-zip" class="required">ZIP</label>
                </ValidationProvider>
                <div class="form-group">
                    <input v-model="address.phone" type="tel" id="phone" v-typed
                           v-mask="'# - (###) ### - ####'"/>
                    <label for="phone">Phone Number</label>
                </div>

                <ValidationProvider class="form-group" rules="required|email"
                                    v-slot="{ errors }">
                    <input v-model="address.email" type="tel" id="f-email"
                           :class="{'invalid': errors.length}"
                           v-typed/>
                    <label for="f-email" class="required">Email</label>
                </ValidationProvider>
                <button type="submit" v-ripple="'rgba(84, 149, 255, 0.35)'">Save & Go Next</button>
                <div class="required-message">
                    Please fill all the required fields
                </div>
            </form>
        </ValidationObserver>
    </div>
</template>

<script>
    import {extend, ValidationObserver, ValidationProvider} from "vee-validate";
    import {email, required} from "vee-validate/dist/rules";
    import vSelect from "vue-select";
    import Countries from "../../data/country";
    import {mapGetters} from "vuex";

    extend('email', email);
    extend('required', {
        ...required,
        message: 'This field is required'
    });
    export default {
        name: "BillingAddress",
        components: {
            vSelect,
            ValidationObserver,
            ValidationProvider
        },
        data: () => ({
            countries: Countries().getCountries(),
            states: [],
            countrySelect: false,
            stateSelect: false,
            submit: false,
            step: 1,
            address: {
                fullName: '',
                address: '',
                country: '',
                city: '',
                state: '',
                zip: '',
                phone: '',
                email: ''
            },
            OpenIndicator: {
                render: createElement => createElement('img', {attrs: {src: require('../../assets/img/icons/arrow-select-gray.svg')}}),
            }
        }),
        computed: {
            ...mapGetters([
                'addressBilling'
            ])
        },
        methods: {
            onSelectFocus(key) {
                this[key] = true;
            },
            onSelectBlur(key) {
                this[key] = false;
                this.submit = true;
            },
            submitForm: function () {
                this.submit = true;
                this.$refs.form.validate().then(success => {
                    const {country, state} = this.address;
                    if (!success || !country.length || !state.length) {
                        return;
                    }

                    this.$store.dispatch('setAddress', this.address)
                    this.$nextTick(() => {
                        this.$emit('set-step', 2);
                    });
                });
            }
        },
        mounted: function () {
            if (this.addressBilling.country) {
                this.address = {...this.addressBilling};
            }
        },
        watch: {
            'address.country': function (val) {
                this.states = Countries().getCountryStates(val);
                if (this.addressBilling.state) {
                    this.address.state = this.addressBilling.state;
                } else {
                    this.address.state = '';
                }
            }
        },
        directives: {
            typed: {
                update: function (el) {
                    el.value.trim().length ? el.classList.add('not-empty') : el.classList.remove('not-empty');
                }
            }
        }
    }
</script>

<style scoped lang="scss">
    form {
        margin-top: 64px;
        width: 468px;
        display: flex;
        flex-wrap: wrap;

        .form-group {
            position: relative;
            margin-top: 32px;
            display: block;
            width: 100%;

            &.country {
                width: 325px;
            }

            &.city {
                width: 208px;
            }

            &.state {
                width: 98px;
                margin-left: 18px;
            }

            &.zip {
                width: 125px;
                margin-left: 18px;
            }

            &.invalid::v-deep {
                .vs__dropdown-toggle {
                    background: rgba(#FF0000, .06);
                    border-color: #FF0000;
                }
            }


            & > input {
                height: 40px;
                @include inputStyle(#4D4D65, #E7E7EA);
            }

            input:focus ~ label,
            input.not-empty ~ label,
            textarea:focus ~ label,
            textarea.not-empty ~ label {
                font-size: 10px;
                font-weight: 700;
                letter-spacing: 0.44px;
                top: -10px;

                &.required:after {
                    width: 5px;
                    height: 5px;
                    transform: translateY(-5px);
                }
            }

            &.focus,
            &.selected {
                label {
                    font-size: 10px;
                    font-weight: 700;
                    letter-spacing: 0.44px;
                    top: -10px;

                    &.required:after {
                        width: 5px;
                        height: 5px;
                        transform: translateY(-5px);
                    }
                }
            }

            label {
                @include label(#ADAEB8);
            }

            &.textarea {
                margin-top: 27px;

                label {
                    top: 23px;
                }
            }

            .maxlength {
                position: absolute;
                right: 6px;
                bottom: 10px;
                color: #9ac1ff;
                font-family: $mainFont, sans-serif;
                font-size: 10px;
                font-weight: 700;
                letter-spacing: 0.44px;

                span {
                    color: #fff;
                }
            }
        }

        button[type=submit] {
            width: 188px;
            height: 38px;
            box-sizing: border-box;
            background-color: #0263FF;
            border-radius: 19px;
            font-family: $mainFont, sans-serif;
            font-weight: 700;
            font-size: 18px;
            letter-spacing: .58px;
            color: #FFFFFF;
            margin-top: 70px;
            border: 0;

            &:hover {
                cursor: pointer;
            }
        }

        .required-message {
            @include requiredMessage();
        }
    }

</style>
